<template>
  <div class="value-change">
    <div class="click-zone" @mousedown="down" @touchstart="down"></div>

    <div class="fullscreen-value-change" v-show="showCircle">
      <span class="number-to-add">{{ value }} <span v-if="valueChange >= 0">+</span>{{ valueChange }} = {{ newValue }}</span>
      <div class="circle"></div>
    </div>
  </div>
</template>

<script>
export default {
  props: ['value', 'friction', 'belowZero'],
  data () {
    return {
      showCircle: false,
      valueChange: 0,
      preciseValueChange: 0,
      centerOfScreen: null,
      previousPoint: null,
      previousTime: null
    };
  },
  computed: {
    newValue () {
      return this.value + this.valueChange;
    }
  },
  methods: {
    down (e) {
      this.showCircle = true;

      this.previousTime = new Date().getTime();

      this.centerOfScreen = {
        x: window.innerWidth / 2,
        y: window.innerHeight / 2
      };

      this.previousPoint = {
        x: this.getClientX(e) - this.centerOfScreen.x,
        y: this.getClientY(e) - this.centerOfScreen.y
      };

      window.addEventListener('mousemove', this.moving);
      window.addEventListener('touchmove', this.moving);
      window.addEventListener('mouseup', this.movingDone);
      window.addEventListener('touchend', this.movingDone);
      document.querySelector('html').style.overflowY = 'hidden';
    },
    moving (e) {
      const currentTime = new Date().getTime();
      const currentPoint = {
        x: this.getClientX(e) - this.centerOfScreen.x,
        y: this.getClientY(e) - this.centerOfScreen.y
      };

      // Pythagorean theorem
      const distance = Math.sqrt(Math.pow(currentPoint.x - this.previousPoint.x, 2) + Math.pow(currentPoint.y - this.previousPoint.y, 2));
      const isClockwise = this.getRotationDirection(this.previousPoint, currentPoint);

      const timeDelta = currentTime - this.previousTime;

      if (timeDelta > 0) {
        let velocity = distance / timeDelta; // in pixels per millisecond
        velocity = (isClockwise) ? velocity : -velocity;

        if (this.value + this.preciseValueChange >= 0 || this.belowZero) {
          this.preciseValueChange += velocity / this.friction;
        } else {
          this.preciseValueChange = -this.value;
        }
      }

      this.valueChange = Math.round(this.preciseValueChange);

      this.previousPoint = currentPoint;
      this.previousTime = currentTime;
    },
    getRotationDirection (previousPoint, currentPoint) {
      return ((previousPoint.x * currentPoint.y) - (previousPoint.y * currentPoint.x)) > 0;
    },
    getAngle (currentTickXPosition, currentTickYPosition) {
      // Not used but is pretty cool cosine law code.
      // You can use this is an alternative way of figuring out the intensity of the movement.
      const a = Math.sqrt(Math.pow((this.previousTickXPosition - this.centerOfCircleX), 2) + Math.pow((this.previousTickYPosition - this.centerOfCircleY), 2));
      const b = Math.sqrt(Math.pow((currentTickXPosition - this.centerOfCircleX), 2) + Math.pow((currentTickYPosition - this.centerOfCircleY), 2));
      const c = Math.sqrt(Math.pow((currentTickXPosition - this.previousTickXPosition), 2) + Math.pow((currentTickYPosition - this.previousTickYPosition), 2));
      return Math.acos((Math.pow(c, 2) - Math.pow(a, 2) - Math.pow(b, 2)) / -(2 * a * b));
    },
    movingDone () {
      this.showCircle = false;

      this.$emit('changeValue', this.valueChange);

      this.valueChange = 0;
      this.preciseValueChange = 0;

      window.removeEventListener('mousemove', this.moving);
      window.removeEventListener('touchmove', this.moving);
      window.removeEventListener('mouseup', this.movingDone);
      window.removeEventListener('touchend', this.movingDone);
      document.querySelector('html').style.overflowY = 'auto';
    },
    getClientX (e) {
      return e.clientX || e.touches[0].clientX;
    },
    getClientY (e) {
      return e.clientY || e.touches[0].clientY;
    }
  }
};
</script>

<style scoped>
.click-zone {
  background-color: red;
  width: 15rem;
  height: 15rem;
}

.fullscreen-value-change {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: color(black alpha(75%));
  display: flex;
  justify-content: center;
  align-items: center;

  & .number-to-add {
    position: absolute;
    top: 0;
    left: 0;
    font-size: 2rem;
    color: white;
  }

  & .circle {
    height: 90vh;
    width: 90vh;
    border-radius: 50%;
    border: 10px solid red;
  }
}
</style>
